(* $Id: main.ml,v 1.3 2006/05/30 17:13:16 deraugla Exp $ *)

open Stdpp;

value print_version () = (
  Printf.eprintf "Budget version 1.1\n";
  flush Pervasives.stderr;
  exit 0
);

value main () = (
  Arg.parse [("-v", Arg.Unit print_version, "print version")]
    (fun s -> File.source.val := s) "Usage: budget [-v] [source]";
  Budget.go ""
);

Printexc.catch
  (fun () ->
     try main () with
     [ Exc_located (p1, p2) exc -> (
         Printf.printf "At some location...\n";
         flush Pervasives.stdout;
         raise exc
       )
     | exc -> raise exc ])
  ()
;
